/*
	Aufgabe4) Exception-Handling

	Beschreibung

	Verwenden Sie zur Lösung der unten angegebenen Methoden nur
	Methoden der Java API (z.B. Integer.parseInt ist erlaubt).

	1. Implementieren Sie die Methode: int stringToInt(String str), die
	den gegebenen Parameter str als int Wert zurückgibt. Sollte es sich
	bei dem Text in str nicht um eine Zahl handeln, dann soll die Methode
	eine NumberFormatException werfen.

	2. Implementieren Sie die Methode: void printStringIfInt(String str),
	die den gegebenen Parameter str auf der Konsole ausgibt, wenn es sich
	dabei um eine ganzzahlige Zahl handelt. Sollte es sich bei dem Text in
	str nicht um eine ganze Zahl handeln, dann soll die Methode den Text: "Keine
	ganze Zahl" ausgeben.

	3. Implementieren Sie die Methode: boolean conditionalString(String str).
	Diese Methode gibt true zurück, wenn alle folgende Bedingungen
	erfüllt sind:
	- Die Länge von str ist > 0 und < 10
	- str enthält keine der folgenden Buchstaben: x, X, y, z
	- Wenn str länger als 5 Zeichen ist, dann muss es genau eine
		Zahl in str geben. Diese Zahl kann aus maximal zwei Ziffern bestehen,
		die aber direkt hintereinander stehen müssen. Beispielsweise wäre:
		halloDu1m2 nicht gültig!

	[fortgeschritten]
	Ist eine dieser Bedingungen nicht erfüllt und wird diese Information
	nicht per Rückgabewert zurückgeliefert (in diesen Fällen würden Unit tests fehlschlagen),
	dann werfen die Methoden, abhängig von der nicht erfüllten Bedingung, eine Exception:
	- Wird die Begingung der Länge von str nicht erfüllt, dann wird
		eine InvalidStringLengthException geworfen. Diese Exception gibt als
		Beschreibung die Länge des Textes aus.
	- Werden unzulässige Buchstaben verwendet, dann wird eine
		InvalidCharException geworfen. Diese Exception listet als Beschreibung
		ALLE unzulässigen verwendeten Zeichen auf.
	- Wird keine Zahl angegeben, wenn str Länger als 5 Zeichen ist,
		dann wird eine NoNumberException geworfen. Diese Exception gibt als
		Beschreibung die Länge des Textes aus.
	- Werden mehrere Zahlen angegeben, wird eine
		MultipleNumberException geworfen. Diese Exception gibt als
		Beschreibung die Anzahl der Ziffern der längsten Zahl in str aus.

		
	Implementieren Sie die oben angegebenen eigenen Exception-Typen:
	- InvalidStringLengthException,
	- InvalidCharException,
	- NoNumberException und
	- MultipleNumberException.

	Zusatzfragen:
	1. Wie unterscheiden sich Exceptions von Rückgabenwerten?
	2. Wann ist es sinnvoller Exceptions und wann
	   Rückgabewerte einzusetzen?
	3. Wie unterscheiden sich checked von unchecked Exceptions? Nennen Sie
	  jeweils drei Beispiele für diese beiden Exceptiontypen.
	4. Wie und warum fängt man Ausnahmen ab?
	5. Welche Ausnahmen können in Java immer an den Aufrufer propagiert werden, welche nicht?
	6. Wie wird nach dem passenden Exception-Handler gesucht?
*/
public class Aufgabe4 {

	public static int stringToInt(String str) throws NumberFormatException{
		/* TODO: add code here */
		return 0;
	}

	public static void printStringIfInt(String str)
	{
		/* TODO: add code here */
	}

	public static boolean conditionalString(String str) throws InvalidStringLengthException, InvalidCharException, NoNumberException, MultipleNumberException
	{
		/* TODO: add code here */
		return false;
	}

	// just for testing ...
	public static void main(String[] args) {
		// Implementierung von main wird nicht beurteilt
	}
}
