/*
    Aufgabe2) final Klassen, final Variablen

    Beschreibung
    
    Erstellen Sie ein System zur Verwaltung von Votingwettbewerben unter Künstlern.
    
    An einer Veranstaltung nehmen Künstler teil. Eine Veranstaltung besteht aus einer Anzahl
    von Performances, bei denen jeweils mehrere Künstler teilnehmen können. Umgekehrt kann ein
    Künstler auch bei mehreren Performances und bei mehreren Veranstaltungen teilnehmen.
    Künstler können sich gegenseitig Punkte für ihre Performances geben. Ihre Implementierung
    einer Veranstaltung weiß nichts konkretes über die Performances (außer die Anzahl)
    soll aber die erhaltenden Punkte für jeden teilnehmenden Künstler berechnen.

    Implementieren Sie die Klasse Kuenstler mit folgenden Eigenschaften:
    - Name
    - Alter

    Implementieren Sie für die Klasse Veranstaltung:
    - einen Konstruktor, der die Anzahl der Performances als Argument übernimmt
    - die Methode teilnehmen(Kuenstler punkteerhalter)
      registriert einen Kuenstler bei der Veranstaltung
    - die Methode points(Kuenstler punkteerhalter)
      welche die Anzahl der Punkte die ein Kuenstler gerade hat zurückgibt
    - die Methode vote(Kuenstler vergeber, Kuenstler erhalter, String bewertung),
      mit der ein Künstler einem anderen Punkte geben kann.
    
    Der String bewertung soll folgendermaßen aufgebaut sein:
    Er beinhaltet eine mit Beistrich getrennte Liste von Performances, welche
    der erhaltende Künster erfolgreich absolviert hat.
    Jede Performance hat eine Prozentzahl (mit % terminiert) welche die subjektive
    Bewertung des vergebenden Künstlers repräsentiert. Die Prozentzahl repräsentiert
    den erreichten Anteil der möglichen fünf Punkte.
      Z.b. 1:20%,3:80%,4:100%
    In diesem Fall hat der Künstler 20% bei der ersten Performance bekommen (also genau
    einen Punkt), bei der zweiten ist er entweder nicht angetreten oder das Ziel wurde
    nicht erreicht, bei der dritten Performance wurde 80% erreicht sowie bei der letzten
    (vierten) Performance wurden alle fünf Punkte erreicht.

    [normal]
    Sie können davon ausgehen, dass der String korrekt formatiert übergeben wird.

    [fortgeschritten]
    Sollte der String das Format nicht erfüllen soll die Methode eine InvalidVoteFormatException
    werfen welche von der InvalidVoteException abgeleitet sein soll.
    Achten Sie auf möglichst alle (mindestens fünf!) Fälle wie der String falsch aufgebaut sein
    kann und testen Sie das mit eigenen Testfällen.

    Überlegen Sie sich außerdem geeignete Datenstrukturen, um die Details einer Veranstaltung
    zu speichern (besonders im Hinblick auf die unten angeführten Votingregeln).

    Votingregeln:
    1. Ein Künstler darf nur anderen Künstlern, die am Wettbewerb
       teilnehmen Votes geben. Ein Künstler muss aber nicht selbst am Wettbewerb
       teilnehmen, um Votes vergeben zu dürfen.
    2. Ein Künstler darf pro Veranstaltung maximal 3 Votes vergeben.
    3. Ein Künstler darf nur ein Mal für einen anderen Künstler voten, der am
       Wettbewerb teilnimmt.
    4. Ein Künstler darf nicht für sich selbst voten.

    Fehlerbehandlung:
    1. Versucht ein Künstler Punkte an jemanden zu geben, der nicht am
       Wettbewerb teilnimmt, soll eine InvalidCandidateException geworfen werden,
       die eine sinnvolle Fehlerbeschreibung beinhaltet.
    2. Versucht ein Künstler mehr als drei Votes zu vergeben, mehrfach Punkte an denselben
       Künstler zu vergeben oder sich selbst zu bewerten, soll eine InvalidVoteException
       geworfen werden, die eine sinnvolle Fehlerbeschreibung beinhaltet.
    3. Ein Aufruf von points(...) mit einem nicht an der Veranstaltung teilnehmenden Künstler
       soll eine InvalidCandidateException werfen, die eine sinnvolle Fehlerbeschreibung ausgibt.
    4. Ein auch von teilnehmen(...) mit einem Künstler, der bereits teilnimmt, soll eine InvalidCandidateException
       werfen, die eine sinnvolle Fehlerbeschreibung beinhaltet.

    Zusatzfragen:
    - Was versteht man unter einer Ausnahmebehandlung?
    - Wofür sind Ausnahmebehandlungen gedacht, wozu sollten sie eher nicht verwendet werden?
      Entspricht die Verwendung der Ausnahmen in dem Beispiel diesen Vorstellungen?
    - Welche Bedeutungen hat das Schlüsselwort final?
    - Wo kann in dieser Aufgabe Schlüsselwort final verwendet werden?

*/
public class Aufgabe2 {

    // just for testing ...
    public static void main(String[] args) {
        // Implementierung von main wird nicht beurteilt
    }
}
